#!/usr/bin/perl

#┌─────────────────────────────────
#│ SUN BOARD : admin.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Sun Board v8.2 PLUS : admin.cgi - 2021/07/24
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
cgi_err('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 条件分岐
if ($in{mente_log}) { mente_log(); }
if ($in{pass_mgr}) { pass_mgr(); }

# 管理モード
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");

	print <<EOM;
<div id="head">
<div id="head-in">
	<strong>:: $cf{bbs_title} ::</strong>
</div>
</div>
<div id="main">
<div id="main-in">
<div align="center">
<p>選択ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl">
<tr>
	<th>選択</th>
	<th width="300">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>&nbsp; パスワード管理</td>
</tr><tr>
	<td><input type="submit" name="mente_log" value="選択"></td>
	<td>&nbsp; 記事メンテナンス（修正/削除）</td>
</tr><tr>
	<td><input type="button" value="選択" onclick="javascript:window.location='$cf{html_url}/index.html'"></td>
	<td>&nbsp; 掲示板へ戻る</td>
</tr><tr>
	<td><input type="button" value="選択" onclick="javascript:window.location='$cf{admin_cgi}'"></td>
	<td>&nbsp; ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	print footer();
	exit;
}

#-----------------------------------------------------------
#  記事メンテナンス
#-----------------------------------------------------------
sub mente_log {

	# 画像許可
	if ($in{mode_chk} && $in{no}) {
		my %chk;
		foreach ( $cgi->param('no') ) {
			$chk{$_}++;
		}

		# 削除情報をマッチング
		my @data;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if (defined($chk{$no})) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$dat<>$nam<>$eml<>$sub<>$com<>$url<>$hos<>$pwd<>$tim<>$col<>$ex<>$w<>$h<>$chk<>$tube<>\n";
			}
			push(@data,$_);
		}

		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除処理
	} elsif ($in{job} eq "dele" && $in{no}) {

		# 削除情報
		my %del;
		foreach ( split(/\0/,$in{no}) ) {
			$del{$_}++;
		}

		# 削除情報をマッチング
		my @data;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if (defined($del{$no})) {

				unlink("$cf{upldir}/$no$ex") if ($ex);
				unlink("$cf{upldir}/$no-s$ex") if (-f "$cf{upldir}/$no-s$ex");
				next;
				}
			push(@data,$_);
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# HTMLファイル更新
		make_html(@data);

	# 修正画面
	} elsif ($in{job} eq "edit" && $in{no}) {

		my @data;
		open(IN,"$cf{logfile}") or &err("open err: $cf{logfile}");
		while (<IN>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if ($in{no} == $no) {
				@data = ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube);
				last;
			}
		}
		close(IN);

		# 修正フォームへ
		edit_form(@data);

	# 修正実行
	} elsif ($in{job} eq "edit2") {

		# 未入力の場合
		if ($in{url} eq "http://") { $in{url} = ""; }
		$in{sub} ||= "無題";

		# 読み出し
		my @data;
		open(DAT,"+< $cf{logfile}") or &err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if ($in{no} == $no) {
				# 添付削除
				if ($in{del}) {
					unlink("$cf{upldir}/$no$ex");
					unlink("$cf{upldir}/$no-s$ex") if (-f "$cf{upldir}/$no-s$ex");
					$ex = $w = $h = '';
				}
				$_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$hos<>$pwd<>$tim<>$in{color}<>$ex<>$w<>$h<>$chk<>$tube<>\n";
			}
			push(@data,$_);
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# HTMLファイル更新
		make_html(@data);

		# 完了メッセージ
		message("記事を修正しました");
	}

	# 記事メンテナンス画面を表示
	header("記事メンテナンス");
	print <<EOM;
<div id="head">
<div id="head-in">
	<strong>:: $cf{bbs_title} ::</strong>
</div>
</div>
<div id="main">
<div id="main-in">
<br />
EOM
	back_btn();

	print <<EOM;

<div class="sub-ttl"> 記事メンテナンス</div>
<ul>
<li>処理を選択して送信ボタンを押してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="mente_log" value="1" />
<input type="hidden" name="sid" value="$in{sid}">
処理：
<select name="job">
<option value="edit">修正</option>
<option value="dele">削除</option>
</select>
<input type="submit" value="送信する" />
EOM

	if ($cf{imgcheck}) {
		print qq|<input type="submit" name="mode_chk" value="添付許可" style="color:white; background-color:rgb(230,192,192); border;0"">\n|;
	}

	# 記事を展開
	open(IN,"$cf{logfile}") or cgi_err("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);
		#$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$eml &&= qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon" alt="メール"></a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="参照URL"></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{html_url}/$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		if (length($com) > 65) { $com = substr($com,0,60); $com .= '.....(略)'; }

		my @col = split(/\s+/, $cf{colors});

		print qq|<div class="log"><input type="checkbox" name="no" value="$no">\n|;
		print qq|[$no] <b>$sub</b> <span style="color:#A688BD">$nam</span> - <span style="color:green">$dat</span> [ <span style="color:#FF9966">$hos</span> ] $eml $url\n|;
		print qq|<div class="com"><span style="color:$col[$col]">$com<\/span><br />$tube</div><div class="clear"></div><br />\n|;

		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			print qq|<dd>添付|;
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[○]"; } else { print "[×]"; }
			}
			print qq|：<a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>\n|;
		}

	}
	close(IN);

	print <<EOM;
<dt><hr size="1" color="#A688BD">
</dl>
</form>
</div>
</div>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$col,$ex,$w,$h,$chk,$tube) = @_;

	$com =~ s|<br( /)?>|\n|g;
	$url ||= "http://";

	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">●</span>\n|;
	}

	my $clip;
	if ($ex) {
		$clip .= qq|[<a href="$cf{uplurl}/$no$ex" target="_blank">添付</a>]\n|;
		$clip .= qq|<input type="checkbox" name="del" value="1">削除\n|;
	} else {
		$clip .= qq|<span style="color:#FF9966;">[ 添付なし ]</span>\n|;
	}

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{html_url}/$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

	header("管理モード ＞ 修正フォーム");
	print <<EOM;
<div id="head">
<div id="head-in">
	<strong>:: $cf{bbs_title} ::</strong>
</div>
</div>
<div id="main">
<div id="main-in">
EOM
	back_btn('mente_log');
	print <<EOM;
<div class="sub-ttl">■ 修正フォーム</div>
<p>★変更する部分のみ修正して送信ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="mente_log" value="1" />
<input type="hidden" name="job" value="edit2" />
<input type="hidden" name="no" value="$no" />
<input type="hidden" name="sid" value="$in{sid}">
<div id="reg-box">
<table id="reg-tbl">
<tr>
  <th><b>おなまえ</b></th>
  <td><input type="text" name="name" size="30" class="reg-name" value="$nam" /></td>
</tr><tr>
  <th><b>Ｅメール</b></th>
  <td><input type="text" name="email" size="30" class="reg-name" value="$eml" /></td>
</tr><tr>
  <th><b>タイトル</b></th>
  <td><input type="text" name="sub" size="50" class="reg-name" value="$sub" /></td>
</tr><tr>
  <th><b>参照先</b></th>
  <td><input type="text" name="url" size="50" class="reg-url" value="$url" /></td>
</tr><tr>
  <th><b>文字色</b></th>
  <td>$color</td>
</tr><tr>
  <th><b>添付</b></th>
  <td>
	$clip<br />
	$tube
  </td>
</tr><tr>
  <th><b>メッセージ</b></th>
    <td><textarea name="comment" class="reg-com" rows="10">$com</textarea>
  </td>
</tr>
</table>
<br>
	<input type="submit" value="送信する" />
	<input type="reset" value="リセット" />
</form>
</div>
<p></p>
<hr class="bottom">
</body>
</html>
EOM
	print footer();
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta http-equiv="content-script-type" content="text/javascript" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript"> 
var ua = navigator.userAgent;
if(ua.indexOf('iPhone') != -1 || ua.indexOf('Android') != -1){
//iPhone & Android
document.write('<link rel="stylesheet" href="./cmn/admin-mobile.css">');
}else{
//PC
document.write('<link rel="stylesheet" href="./cmn/admin.css">');
}
</script>
<!-- start lightview v3.5.1 -->
<script type="text/javascript" src="http://code.jquery.com/jquery-3.1.0.min.js"></script>
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/swfobject/2.2/swfobject.js"></script>
<!--[if lt IE 9]>
  <script type="text/javascript" src="./lightview-3.5.1/js/excanvas/excanvas.js"></script>
<![endif]-->
<script type="text/javascript" src="./lightview-3.5.1/js/spinners/spinners.min.js"></script>
<script type="text/javascript" src="./lightview-3.5.1/js/lightview/lightview.js"></script>
<link rel="stylesheet" type="text/css" href="./lightview-3.5.1/css/lightview/lightview.css" />
<!-- end lightview v3.5.1 -->
<title>$ttl</title>
</head>
<body>
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub cgi_err {
	my $err = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350" />
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350" />
<form>
<input type="button" value="前画面に戻る" onclick="history.back()" />
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div align="center" style="margin-top:3em;">
<hr width="350" />
<p class="msg">$msg</p>
<hr width="350" />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="管理画面に戻る" />
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;

	print <<EOM;
<div class="ta-r">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : "" ]}
<input type="submit" value="▲メニュー">
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	my $i = 0;
	my ($ret,$flg);
	while ($str =~ /([\x00-\x7f]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/gx) {
		$i++;
		$ret .= $1;
		if ($i >= $all) {
			$flg++;
			last;
		}
	}
	$ret .= '...' if ($flg);
	
	return $ret;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

