#!/usr/bin/perl

#┌─────────────────────────────────
#│ SUN BOARD : check.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Sun Board v8.3 PLUS : check.cgi - 2022/11/22
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 外部ファイル取り込み
require './init.cgi';
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
EOM

# ディレクトリ
my %dir = (
	$cf{html_dir}        => 'HTMLファイル(TOP PAGE)のディレクトリ',
	$cf{cmnurl}          => '共用ディレクトリ(admin.css etc.)',
	$cf{datadir}         => 'データディレクトリ',
	$cf{upldir}          => '画像アップロードディレクトリ',
	"$cf{datadir}/past"  => '過去ログディレクトリ',
	"$cf{datadir}/pwd"   => '管理パスワードディレクトリ',
	"$cf{datadir}/ses"   => '管理パスワードセッションディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		#next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# データファイル
my %log = (
	"$cf{datadir}/log.cgi"       => '記事ログファイル',
	"$cf{datadir}/html.dat"      => 'HTML番号ファイル',
	"$cf{datadir}/pastno.dat"    => '過去ログデータ番号ファイル',
	"$cf{datadir}/pass.dat"      => '管理パスワードデータファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# テンプレート
foreach (qw(album album_past bbs edit error find form message note past pwd)) {
	if (-f "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM
exit;

