# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ SUN BOARD : init.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2020
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'Sun Board v8.3';
#┌─────────────────────────────────
#│ [留意事項]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Sun Board v8.3 PLUS : init.cgi - 2022/03/10
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 設定項目
#===========================================================

# 掲示板タイトル
$cf{bbs_title} = $cf{version};

# 返信フォームキャプション
$cf{form_cap01} = '■ 返信フォーム';

# 投稿フォームキャプション
$cf{form_cap02} = '■ 新規投稿フォーム';

# CGIファイルのディレクトリURL【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{cgi_url} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83";

# HTMLファイルのディレクトリURL【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{html_url} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/html";

# HTMLファイルのディレクトリパス【サーバパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{html_dir} = "./html";

# 戻り先 (index.htmlなど)【URLパス】
# → http://からの絶対パスで記述
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{homepage} = "https://www.transformsite.com/";

# アイコンディレクトリ【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{iconurl} = 'https://www.transformsite.com/sample/normal_bbs/sunbbs83/icon';

# アイコン【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{ico_clip} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/icon/blue_clip.gif";
$cf{ico_img} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/icon/Pictures.gif";
$cf{ico_home} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/icon/house.png";
$cf{ico_mail} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/icon/mail.png";

# lightview-3.5.1ディレクトリ【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{lightview} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/lightview-3.5.1";

# 文字コード自動判別（0=no 1=yes）
# → フォーム入力の文字コード判別を行う場合
$cf{conv_code} = 0;

# YouTubeを表示する
$cf{tube} = 1;

# Youtubeアイコン
$cf{tube_ico} = "tube_icon.png";

# アップロードディレクトリ【サーバパス】
$cf{upldir} = "./upl";

# アップロードディレクトリ【URLパス】
# 必ず設置先のURLに変更して下さい（下記は「サイト:TRANSFORM」の設置先{サンプル}になっています）
$cf{uplurl} = "https://www.transformsite.com/sample/normal_bbs/sunbbs83/upl";

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;

# アップファイル管理者チェック機能
# → アップされた添付ファイルは管理者がチェック後に表示
# 0=no 1=yes
$cf{imgcheck} = 0;

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 250;	# 横幅
$cf{max_img_h} = 150;	# 縦幅

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 0;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF

# 記事の最大保持数
$cf{maxlog} = 100;

# ページ当りの記事数
# → 順に、スレッド表示、アルバム表示
$cf{pg_max} = 10;
$cf{max_albums} = 3;

# 自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# 本体CGI [ ファイル名のみ ]
$cf{bbs_cgi} = 'sunbbs.cgi';

# 投稿CGI [ ファイル名のみ ]
$cf{regist_cgi} = 'regist.cgi';

# 管理CGI [ ファイル名のみ ]
$cf{admin_cgi} = 'admin.cgi';

# データファイル【サーバパス】
$cf{logfile} = './data/log.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# HTMLインデックスファイル【サーバパス】
$cf{htmldat} = './data/html.dat';

# テンプレートディレクトリ
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#808080 #C0C0C0 #666666 #80B3DE #398ED9 #8d93c8 #6c2463 #a688bd #98605e #ea5550 #da81b2 #e3acae #ffdc00 #f39800 #79c06e #417038';

# メール通知機能
# → 0=no  1=yes
$cf{mailing} = 0;

# メール通知先アドレス（メール通知する場合）
$cf{mailto} = 'xxx@xxx.xx';

# sendmailのパス（メール通知する場合）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 記事の更新は method=post に限定する場合（セキュリティ対策）
#  → 0=no 1=yes
$cf{postonly} = 1;

# 投稿制限（セキュリティ対策）
#  0 : しない
#  1 : 同一IPアドレスからの投稿間隔を制限する
#  2 : 全ての投稿間隔を制限する
$cf{regCtl} = 1;

# 制限投稿間隔（秒数）
# → $regCtl での投稿間隔
$cf{wait} = 60;

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = '';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 1;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '';

# １回当りの最大投稿サイズ (bytes)
# 10240000 = 10Mb
$cf{maxdata} = 10240000;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id} = "sunboard";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能の設定 ]

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
$cf{pastdir} = './data/past';

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{max_line} = 500;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 1;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captchasunbbs';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "stamp.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定値を返す
sub set_init {
	return %cf;
}

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行処理
			$val =~ s/\r\n/<br>/g;
			$val =~ s/\r/<br>/g;
			$val =~ s/\n/<br>/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!css-url!/$cf{html_url}\/sunbbs.css/g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  HTML生成処理
#-----------------------------------------------------------
sub make_html {
	my @log = @_;

	my $all = @log;

	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{html_url}/$1" alt="" class="icon" />|g;

	# テンプレート分割
	$tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s;
	my ($head,$loop,$foot) = ($1,$2,$3);

	# 文字置換
	foreach ($head,$loop,$foot) {
		s/!homepage!/$cf{homepage}/g;
		s/!([a-z]+_cgi)!/$cf{cgi_url}\/$cf{$1}/g;
		s/!css-url!/$cf{html_url}\/sunbbs.css/g;
		s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
		s|!lightview!|$cf{lightview}|g;
		s/!menu-url!/$cf{html_url}\/inspire-brown.css/g;
		s/!bbs-(title|message)!/$cf{"bbs_$1"}/g;
		s|!ico:(\w+\.\w+)!|<img src="$cf{iconurl}/$1" class="icon">|g;
	}

	# 各ページ作成
	my $bbsno = 1;
	for ( my $i = 0; $i <= @log; $i += $cf{pg_max} ) {

		my $end = $i + $cf{pg_max} - 1;
		if ($end > $#log) { $end = $#log; }

		my $data;
		foreach ($i .. $end) {
			my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$time,$col,$ex,$w,$h,$chk,$tube) = split(/<>/,$log[$_]);
			$eml &&= qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon" alt="メール"></a>| if ($eml);
			#$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
			$com = auto_link($com) if ($cf{autolink});
			$com =~ s/([>]|^)(&gt;[^<]*)/$1<span class="refcol">$2<\/span>/g;
			#$url &&= qq|<a href="$url" target="_top">参照先</a>|;
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="参照URL"></a>|;

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{html_url}/$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		if ($ex) {
			# 確認待ち
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<p>[添付]: 認証待ち (<b style="color:#FF9966">$size</b>)</p>|;

			# 添付画像
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = resize($w,$h); #サムネイル
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}
				$com = qq|<a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="投稿者：$nam　タイトル：$sub" data-lightview-group-options="skin: 'mac'"><img $op border="0" align="left" hspace="18" class="snapshot"></a>$com<br clear="all">|;

			# 画像以外
			} else {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<p>添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> (<b>$size</b>)</p>|;
			}
		}

			my @col = split(/\s+/, $cf{colors});

			my $tmp = $loop;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s/!sub!/$sub/g;
			$tmp =~ s/!name!/$nam/g;
			$tmp =~ s/!email!/$eml/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!url!/$url/g;
			$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
			$tmp =~ s|!ico_edit!|<a href="$cf{cgi_url}/$cf{bbs_cgi}?mode=pwd&no=$no"><img src="$cf{iconurl}/Edit.png" class="clip" title="記事編集" alt="記事編集"></a>|g;
			$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
			$data .= $tmp;
		}

		# 生成ページ定義
		my $html;
		if ($i == 0) {
			$html = 'index.html';
		} else {
			$bbsno++;
			$html = "bbs-$bbsno.html";
		}

		# 繰越ボタン
		my $page_btn = make_pgbtn($all,$bbsno) if (@log > $cf{pg_max});
		my ($tmp1,$tmp2) = ($head,$foot);
		$tmp1 =~ s/<!-- pager -->/$page_btn/g;
		$tmp2 =~ s/<!-- pager -->/$page_btn/g;

		# フッタ部
		$tmp2 = footer($tmp2);

		# 書込み
		open(DAT,"+> $cf{html_dir}/$html") or error("write err: $html");
		eval "flock(DAT, 2);";
		print DAT $tmp1, $data, $tmp2;
		close(DAT);
	}

	# HTMLインデックス更新
	open(IDX,"+< $cf{htmldat}") or error("open err: $cf{htmldat}");
	my $data = <IDX>;
	seek(IDX, 0, 0);
	print IDX $bbsno;
	truncate(IDX, tell(IDX));
	close(IDX);

	# 不要HTML削除
	if ($bbsno < $data) {
		foreach my $i ($bbsno .. $data) {
			unlink("$cf{html_dir}/bbs-$i.html");
		}
	} elsif ($bbsno > $data) {
		foreach my $i ($data .. $bbsno) {
			chmod(0666, "$cf{html_dir}/bbs-$i.html");
		}
	}
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg) = @_;
	my $pg2 = ($pg - 1) * $cf{pg_max};

	# ページ繰越定義
	my $next = $pg2 + $cf{pg_max};
	my $back = $pg2 - $cf{pg_max};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 or $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $x) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>\n!);
			} else {
				my $link = $x == 1 ? 'index.html' : "bbs-$x.html";
				push(@pg,qq!<li><a href="$link">$x</a></li>\n!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		my $x = $back / $cf{pg_max} + 1;
		my $link = $x == 1 ? 'index.html' : "bbs-$x.html";
		$ret = qq!<li><a href="$link">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		my $x = $next / $cf{pg_max} + 1;
		my $link = $x == 1 ? 'index.html' : "bbs-$x.html";
		$ret .= qq!<li><a href="$link">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
	- <a href="https://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</p>
EOM

	my $ret;
	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		$ret .= "$1$copy$2\n";
	} else {
		$ret .= "$foot$copy\n";
		$ret .= "</body></html>\n";
	}
	return $ret;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}



1;

