#!/usr/bin/perl

#┌─────────────────────────────────
#│ SUN BOARD : sunbbs.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Sun Board v8.0 PLUS - 2021/07/24
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 条件分岐
if ($in{mode} eq 'form') { bbs_form(); }
if ($in{mode} eq 'find') { find_data(); }
if ($in{mode} eq 'note') { note_page(); }
if ($in{mode} eq 'album') { album(); }
if ($in{mode} eq 'album_past') { album_past(); }
if ($in{mode} eq "past") { past_log(); }
if ($in{mode} eq 'pwd') { pwd_form(); }
if ($in{mode} eq 'expound') { expound_page(); }
error("不明な処理です");

#-----------------------------------------------------------
#  投稿フォーム
#-----------------------------------------------------------
sub bbs_form {
	# レス処理
	$in{res} =~ s/\D//g;
	my %res;
	if ($in{res}) {
		my $flg;
		open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
		while (<IN>) {
			my ($no,$sub,$com) = (split(/<>/))[0,4,5];
			if ($in{res} == $no) {
				$flg++;
				$res{sub} = $sub;
				$res{com} = $com;
				last;
			}
		}
		close(IN);

		if (!$flg) { error("該当記事が見つかりません"); }

		$res{sub} =~ s/^Re://g;
		$res{sub} =~ s/\[\d+\]\s?//g;
		$res{sub} = "Re:[$in{res}] $res{sub}";
		$res{com} = "&gt; $res{com}";
		$res{com} =~ s|<br( /)?>|\n&gt; |ig;
	}

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($cook[3] == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">●</span>\n|;
	}

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/form.html") or error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# 文字置き換え$cf{lightview}
	$tmpl =~ s|!css-url!|$cf{html_url}/sunbbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
	$tmpl =~ s|!lightview!|$cf{lightview}|g;
	$tmpl =~ s|!bbs-url!|$cf{html_url}/index.html|g;
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{cgi_url}\/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!sub!/$res{sub}/;
	$tmpl =~ s/!comment!/$res{com}/;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!color!/$color/g;

	my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$time,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

	if ($in{res}) {
	$tmpl =~ s|<!-- form_caption01 -->|$cf{form_cap01} <span style="font-size:11pt;">NO.<b style ="color:#FF9966; font-size:12pt;">$no</b>に返信</span>|g;
	} else {
	$tmpl =~ s/<!-- form_caption02 -->/$cf{form_cap02}/g;
	}

	# 表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print footer($tmpl);
	exit;
}

#-----------------------------------------------------------
#  YouTube貼付方法
#-----------------------------------------------------------
sub expound_page {

	open(IN,"$cf{tmpldir}/expound.html  ") or error("open err: expound.html  ");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs-url!|$cf{html_url}/index.html|g;
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;
	$tmpl =~ s|!css-url!|$cf{html_url}/sunbbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}


#-----------------------------------------------------------
#  ワード検索
#-----------------------------------------------------------
sub find_data {
	# 条件
	$in{cond} =~ s/\D//g;

	# 検索条件プルダウン
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected="selected">$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# 検索実行
	my ($hit,@log) = search_log($in{word},$in{cond},$cf{logfile}) if ($in{word} ne '');

	# テンプレート
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 検索前のとき
	$tmpl =~ s/<!-- hitmsg_begin -->.+<!-- hitmsg_end -->//s if ($in{word} eq '');

	# 文字変換
	$tmpl =~ s|!css-url!|$cf{html_url}/sunbbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
	$tmpl =~ s|!lightview!|$cf{lightview}|g;
	$tmpl =~ s|!bbs-url!|$cf{html_url}/index.html|g;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/;
	$tmpl =~ s/!word!/$in{word}/;
	$tmpl =~ s/!hit!/$hit/;
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;

	# 分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# ヘッダ部
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# ループ部
	foreach my $log (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/, $log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com  = auto_link($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span class="refcol">$2<\/span>/g;
		$url  = qq|&lt;<a href="$url" target="_blank">URL</a>&gt;| if ($url);

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{html_url}/$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[添付]: 認証待ち ($size)</div>|;
			} else {
				$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>|;
			}
		}

		my @col = split(/\s+/, $cf{colors});

		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		print $tmp;
	}

	# フッタ
	print footer($foot);
	exit;
}

#-----------------------------------------------------------
#  検索実行
#-----------------------------------------------------------
sub search_log {
	my ($word,$cond,$file,$list) = @_;

	# キーワードを配列化
	$word =~ s/　/ /g;
	my @wd = split(/\s+/,$word);
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	# 検索処理
	my $i = 0;
	my @log;
	open(IN,"$file") or error("open err: $file");
	while (<IN>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		$i++;
		if ($list > 0) {
			next if ($i < $in{pg} + 1);
			next if ($i > $in{pg} + $list);
		}

		push(@log,$_);
	}
	close(IN);

	# 検索結果
	return ($i,@log);
}

#-----------------------------------------------------------
#  パスワードフォーム
#-----------------------------------------------------------
sub pwd_form {

	$in{no} =~ s/\D//g;

	# 記事
	my ($name,$pwd);
	open(DAT,"+< $cf{logfile}") || &error("Open Error: $cf{logfile}");
	while (<DAT>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);

	if ($in{no} == $no) {
		$name = $nam;
		$pwd = $pw;
		last;
		}
	}
	close(DAT);

	# パスワード未設定
	error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$com  = &autolink($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{iconurl}/home.gif" class="home"></a>|;
		if (length($com) > 135) { $com = substr($com,0,130); $com .= '.....(略)'; }

	# YouTube
	if ($cf{tube}) {
		$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a href="https://www.youtube.com/embed/$1" class="lightview" data-lightview-type="iframe" data-lightview-options="width: 845,height: 480, viewport: 'scale'"><img src="$cf{html_url}/$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
	}

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[添付]: 認証待ち (<span style="color:#00a1e9">$size</span>)</div>|;
			} else {
				$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" class="lightview" data-lightview-title="$sub" data-lightview-group-options="skin: 'mac'">$no$ex</a> (<span style="color:#00a1e9">$size</span>)</div>|;
			}
		}

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/pwd.html") or &error("open err: pwd.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!css-url!|$cf{html_url}/sunbbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;

	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{cgi_url}\/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs-url!|$cf{html_url}/index.html|g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!name!/$nam/g;
	$tmpl =~ s/!home!/$url/g;
	$tmpl =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
	$tmpl =~ s/<!-- clip -->/$clip/;
	$tmpl =~ s/<!-- youtube -->/$tube/ if ($tube);

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	&footer();

	exit;
}

#-----------------------------------------------------------
#  アルバム機能
#-----------------------------------------------------------
sub album {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# データ読み込み
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$nam\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = album_pgbtn($i,$pg,'&mode=album',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/<!-- pager -->/$page_btn/g;
		s/!bbs-url!/$cf{html_url}\/index.html/g;
		s/!css-url!/$cf{html_url}\/sunbbs.css/g;
		s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
		s|!lightview!|$cf{lightview}|g;
		s|!bbs_title!|$cf{bbs_title}|g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$nam,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$nam,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	print footer($foot);
	exit;
}

#-----------------------------------------------------------
#  アルバム機能 (過去ログ)
#-----------------------------------------------------------
sub album_past {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album_past.html") or error("open err: album_past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# データ読み込み
	my ($i,@img);
	open(IN,"$file") or error("open err: $file");
	while (<IN>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = album_pgbtn($i,$pg,'&mode=album_past',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/<!-- pager -->/$page_btn/g;
		s/!bbs-url!/$cf{html_url}\/index.html/g;
		s/!css-url!/$cf{html_url}\/sunbbs.css/g;
		s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
		s|!bbs_title!|$cf{bbs_title}|g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$nam,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$nam,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	print footer($foot);
	exit;
}

#-----------------------------------------------------------
#  繰越ボタン作成 (アルバム)
#-----------------------------------------------------------
sub album_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# ページ繰越定義
	my $next = $pg + $max;
	my $back = $pg - $max;

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  画像表示
#-----------------------------------------------------------
sub image {
	my ($no,$nam,$sub,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{upldir}/$no-s$ex") {
		$image = qq|<img src="$cf{upldir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{upldir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a href="$cf{upldir}/$no$ex" class="lightview" data-lightview-title="投稿者：$nam　タイトル：$sub" data-lightview-group="sunbbs-set" data-lightview-group-options="skin: 'mac'">$image</a>\n|;
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {

		open(IN,"$cf{tmpldir}/note.html") or &error("open err: note.html");
		my $tmpl = join('', <IN>);
		close(IN);

		$tmpl =~ s|!css-url!|$cf{html_url}/sunbbs.css|g;
		$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
		$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;
		$tmpl =~ s|!bbs-url!|$cf{html_url}/index.html|g;

	print "Content-type: text/html; charset=utf-8\n\n";
		print $tmpl;
		exit;
}

#-----------------------------------------------------------
#  過去ログ画面
#-----------------------------------------------------------
sub past_log {
	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d",$pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# プルダウンタグ作成
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected="selected">$i\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# 初期化
	my ($hit,$page_btn,@log);

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# ワード検索
	if ($in{find} && $in{word} ne '') {
		# 検索結果
		($hit,@log) = search_log($in{word},$in{cond},$file,$in{list});
		$page_btn = "検索結果：<b>$hit</b>件 &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,'past');

	# ログ一覧
	} else {

		# 過去ログオープン
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			$i++;
			next if ($i < $pg + 1);
			next if ($i > $pg + $cf{pg_max});

			push(@log,$_);
		}
		close(IN);

		# 繰越ボタン作成
		$page_btn = pgbtn_old($i,$in{pno},$pg);
	}

	# プルダウン作成（検索条件）
	my %op = make_op();

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	# 文字置換
	$tmpl =~ s/!past_num!/$in{pno}/g;
	$tmpl =~ s/!bbs-url!/$cf{html_url}\/index.html/g;
	$tmpl =~ s/!css-url!/$cf{html_url}\/sunbbs.css/g;
	$tmpl =~ s|!mob_css!|$cf{html_url}/sunbbs-mobile.css|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/<!-- op_pno -->/$op_pno/g;
	$tmpl =~ s/<!-- op_(\w+) -->/$op{$1}/g;
	$tmpl =~ s/!word!/$in{word}/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	if ($in{change}) { $in{word} = ''; }

	# 画面表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@log) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$col,$ex,$w,$h,$chk,$tube) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$com = auto_link($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span class="refcol">$2<\/span>/g;
		$url  = qq|<a href="$url" target="_blank">$url</a>| if ($url);

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[添付]: 認証待ち ($size)</div>|;
			} else {
				$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>|;
			}
		}

		my @col = split(/\s+/, $cf{colors});

		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		$tmp =~ s/!num!/$no/g;
		print $tmp;
	}

	# フッタ
	print footer($foot);
	exit;
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  繰越ボタン作成 [ 過去ログ ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$stat) = @_;

	# ページ繰越定義
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	my $link;
	if ($stat eq 'past') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno&amp;find=1&amp;word=$wd";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno";
	}

	# ページ繰越ボタン作成
	my $pg_btn;
	if ($back >= 0 || $next < $i) {
		$pg_btn .= "Page: ";

		my ($x, $y) = (1, 0);
		while ($i > 0) {
			if ($pg == $y) {
				$pg_btn .= qq(| <b>$x</b> );
			} else {
				$pg_btn .= qq(| <a href="$link&pg=$y">$x</a> );
			}
			$x++;
			$y += $cf{pg_max};
			$i -= $cf{pg_max};
		}
		$pg_btn .= "|";
	}
	return $pg_btn;
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  プルダウン作成 [ 検索条件 ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected="selected">$cond{$_}\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected="selected">$i件\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i件\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024000 ? comma(int($size/1024000)) . 'MB' : $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

